Cover

WinWulff

Version 1.6

Stereographic Projections of Poles and Zone Axes

© JCrystalSoft 2006-2018


Introduction

WINWULFF is a crystallographic application for plotting stereographic projections, i.e. pole diagrams of either reciprocal space vectors (hkl) or direct space vectors/zone axes [uvw].

WINWULFF is the successor to JWulff, the Java application, which is also included with JCrystal.

The graphical user-interface is intuitive and very interactive. The virtual crystal can be rotated by dragging the mouse with the left / right mouse button depressed. Zooming is done in the same manner. Left/Right clicking at a spot shows its indices or draws the corresponding zone trace.

Main Features

  • Multi-Document Interface
  • Plot (hkl) and/or [uvw]
  • Plot upper, lower or both hemispheres
  • Draw zone traces
  • Draw unit cell-outline
  • Import editable *.hkl files
  • Export BMP, JPG images
  • Export Adobe Acrobat PDF files
  • Export hkl lists as *.hkl or *.txt files
  • Observe extinction conditions during HKL generation
  • Overlay Multiple Plots of Different Crystals
  • Import Background Image (JPG/GIF/BMP)
  • Import Alpha/Beta Angle Files

Sample Menu

At program start the file ..\lib\cellmenu.txt will be loaded for the menu [Samples]. This file is editable, so you can input materials of your own interest. The change will be effective at the next program start.

Format of the file cellmenu.txt (name,spacegroup number,spacegroup symbol,cell)
'You may edit this file. Up to 30 cells can be added to the Samples-menu.
'No spaces allowed within the spacegroup symbols
Cu        : 225  FM3M    3.6174   3.6174   3.6174  90   90     90
Si        : 227  FD3M    5.4307   5.4307   5.4307  90   90     90
W         : 229  IM3M    3.16522  3.16522  3.16522 90   90     90
'you can comment out a line by starting the line with '
'save changes and restart WinWulff to update the menu [Samples]

Multi Documents

If you open too many windows you may want to close some down, in order to reduce the program's memory requirements for the hkl sets.

HKL Import

Editable hkl-data files can be exported and imported, thus giving the user the ability to plot user-defined sets of hkl/uvw vectors. The format is as follows: The first line contains the unit cell constants, the second line specifies the number of vectors and then follows the list of h k l values (separated by SPACE).

3.2094 3.2094 5.2103 90.0 90.0 120.0
 130
  -1   0   0
   0  -1   0
   0   1   0
   1   0   0
  -1   1   0
   1  -1   0
   0   0   2
...

Alpha/Beta Angle Import

Simple alpha/beta text files (*.ab) can be imported, thus giving the user the ability to overlay user-defined angular data sets. The files can be created easily using MS Window's Wordpad or Notepad.

From the "Open"-dialog, select the file filter "Alpha-Beta Input File (*.ab)". Then locate the desired data file and click the "Open"-button.

The format is as follows: The first line contains the number of data points, an optional coordinate system specifier and the angular unit specifier. Starting from the second line the alpha, and beta values are given (an optional third column specifies the text label).

The coordinate system specifier (default= CE)can be modified to create 16 different coordinate systems, with alpha-zero either in the center or at the edge of the stereo circle. The beta-zero position can be at the four quadrant positions and the sense of rotation can be either mathematically positive (i.e. counter-clockwise; that is the default) or negative (clock-wise).

Used abbreviations:
Alpha-zero: (C) Center, (E) Edge
Beta -zero: (N) North, (E) East, (S) South, (W) West, (+) Positive, (-) Negative
AngleUnit : (DEG) Degree, (RAD) Radian

Some valid coordinate system specifiers would be:

CE+, CN+, CW+, CS+, CE-, CN-, CW-, CS-
(Alpha-zero in center, Beta-zero at East, North, West, South with positive or negative rotation)

EE+, EN+, EW+, ES+, EE-, EN-, EW-, ES-
(Alpha-zero at the edge of the stereo circle, Beta-zero as above)

Sample *.ab file with 13 data points

13 CE DEG
   0   0   A
  90   0   B
  90  45   C
  90  90   D
  10  30   E
  20  40   F
  30  50   G
  40  60   H
  50  70   I
  60  80   J
  70  100  K
  80  120  L
  90  140  M
  ...

The Alpha/Beta data will be overlaid onto the current hkl/uvw poles. If you only want to see the Alpha/Beta data then move the d-Spacing slider to the very right in order to make the hkl/uvw poles disappear.

New in version 1.4.0: The Alpha/Beta data can now be imported as a rotatable set of pseudo-hkl

Background Image Import

From the "Open"-dialog, select the file filter "Background Image File (*.jpg, *.gif, *.bmp)". Then locate the desired image file and click the "Open"-button.

The background image may be moved by pressing the Ctrl-Key and the arrow keys (up/down/left/right). In a similar manner the image may be resized by pressing the Ctrl-key and the plus/minus key.

Under the [View] menu the item [Background Image] becomes visible, which can be selected to hide/show the loaded image.

Printing

At the moment no high-quality vector graphics printing is implemented. Instead the on-screen image will be printed as pixel graphics (the larger the image the better the printing quality will be).

The printing of Wulff-Net/Polar-Net templates is implemented as high-resolution vector graphics (see menu [Tools]).

Symmetrical UVW Plots (new in 1.1.0)

WINWULFF creates the vector list (hkl) as a spherical volume in reciprocal space so that it will show the crystal symmetry. In crystal systems other than the cubic system those vectors may not reveal the crystal symmetry when plotted as zone axes [uvw], due to the unit cell geometry. If you wish to create a symmetrical [uvw] set you may click at the [Apply] button with the Right-Mouse Button. After answering two questions the program will create a spherical volume in direct space, so that the lattice vectors [uvw] may show the expected symmetry.

Feedback

Please contact me if you have a bug to report.

Author
Steffen Weber, Ph.D.
 jcrystalsoft@gmail.com


GUI Overview

Components of the multi-document interface with one document window.

  • Main menu
  • Main Toolbar
  • Control panel for individual document window
  • Display option sliders (zoom, labels, d-spacing, spot size)
  • Main status bar
  • Plot type (Stereogram / 3D-HKL)
  • Approximate orientation [uvw]/(hkl)
  • Main display (left/right mouse-button-drag for rotation,zoom; right-click for zone trace)
  • Tabs for other display options
  • Message area

  • Zoom - Use top slider or right-mouse-button-drag up/down on right side of display
  • Rotate - Use left-mouse-button-drag and right-mouse-button-drag on left side of display.
  • Index - Left-click on spot to get its indices and angle rho
  • Zone - Right-click on spot to draw the zone trace for that vector. Click at spot again to delete trace
    All traces can be deleted from the menu [View][Clear Zones]

Toolbar

  1. Load a new/blank document window
  2. Load a HKL file (*.hkl)
  3. Save image or hkl data
  4. Save image as Adobe Acrobat file (*.pdf)
  5. Copy image or data to clipboard
  6. Print image
  7. Calculate angles between (hkl) or [uvw] vectors
  8. Toggle background color
  9. Toggle labels (hkl/uvw indices)
  10. Toggle d-Spacing spot coloring
  11. Reset zoom
  12. Toggle Wulff-net
  13. Toggle Polar net
  14. Plot (hkl)-poles (reciprocal space vectors)
  15. Plot [uvw]-directions (direct space vectors)
  16. Plot upper hemisphere (default)
  17. Plot lower hemisphere
  18. Plot both hemispheres

Other Display Options

Unit cell outline. Drag with the mouse for rotation, which is synchronized with the stereogram:

Tiled view for plot and unit cell. Rotations by mouse-drag are synchronized:

List of generated or imported hkl:

Generated HKL angle table. Specify a "main h k l" if you want to know the angles for that pole only. Double-Click on text area to open it in wordpad.


GUI Controls

Vector Input Convention

When a vector such as the orientation vector is input use spaces for separation if any of the indices is negative or is larger than 9 (e.g.: -1 10 6). If the vector string is only three characters long, no spaces are needed (e.g.: 111)

Control panel

Each document window has its own control panel on the left side.

  1. Space-group selection for extinction conditions
  2. Unit cell (enter manually or from menu [Samples])
  3. Title (also used as title in PDF export)
  4. d-Spacing range for hkl generation
  5. Click at this label for reorienting to specified vector
  6. Orientation vector (either select or type in a new one and press ENTER)
    and vector type (hkl/uvw)
  7. Execute hkl-generation
  8. Plot-type (3D-hkl/Stereogram)
  9. Display sliders (zoom, d-threshold, label-threshold, spot size)
  10. Angle increments for user-defined rotation
  11. Left/Right mouse-click for rotation in positive/negative direction

Note: The program does not try to check if your space-group selection is sensible

Mouse Conventions

Display example for 3D-hkl with cell-monitor and Wulff-monitor switched on.

The main display area is divided into a left and a right side. When dragging with the left-mouse-button depressed no distinction is made and the virtual crystal is rotated about the two in-plane axes.

When dragging with the right-mouse-button depressed on the left side the virtual crystal is rotated about the screen normal axis (viewing direction).

When dragging up/down with the right-mouse-button depressed on the right side the zoom factor is changed (for zoom one also may use the zoom slider).

Spot clicking in Stereogram mode

When clicking at a spot with the left-mouse-button that spot is highlighted and its indices are shown.

When clicking at a spot with the right-mouse-button that spot is highlighted and the corresponding zone trace is drawn. clicking at the spot again will remove the trace. All zone traces can be removed from the menu [View][Clear Zones]


Plot Overlays

Redirecting Graphics Output

- Upper Hemisphere Stereogram Only -

If you want to overlay one/several different plots onto one you can do this by opening several document windows, each with its own crystal data. Then select one of them as the primary plot by clicking at that window (to make it the active form) and then selecting the menu [Tools][Make Overlay Host].

Bring the primary plot to the desired orientation, then you can rotate/orient a crystal in one of the other windows and its plot will be overlaid onto the primary plot in the specified overlay-color.

If you want to overlay another crystal, click the [!]-button on the primary plot window next to the color button, in order to keep the current image, then rotate/orient the next crystal for overlaying its plot on the primary plot, too. Note that if the primary plot is redrawn by dragging or else the current overlay image will be gone, since it is only a temporary image.

Only spots, labels and axes directions will be redirected for an overlay, not zone traces. Spot sizes are uniform in overlay mode, but the individual spot-size sliders may be used for modifying the spot radius factor.

To return to the normal plot mode select again the menu [Tools][Make Overlay Host].

Example Screenshot

This figure shows how three arbitrary plots are overlaid. The primary plot (i.e. overlay host) is the larger window on the left.

  1. 'Fix current image' - button
  2. Overlay color buttons (click to edit color)


New in 1.3.0

New Features in 1.3.0

1 - List/Export 2-Theta Values

The hkl-List tab now shows a column with 2-Theta values (X-ray diffraction angles). The default wavelength is 1.54056 (Cu-Anode). When you click at the column header you will be prompted to enter a different wavelength in Angstrom [A]. No values will be listed for those hkl indices, for which the 2-Theta value would not fall within the allowed range (0-180 deg). If that happens, increase the d-min value, in order to reduce the number of generated hkl.

Use the menu [File][Save As.. ][HKL-2Theta File (*.hkl2t)] for exporting the data to a ASCII (text) file.

2 - Delete Poles

For deleting individual hkl only, select a row in the hkl-List and press the Delete-key. When you Right-Click at a pole in the Wulff-net a pop-up menu appears, from which you may choose "Delete Pole". This will delete the selected pole and all other poles, whose projection falls onto the same spot (higher orders).

3 - Use Pole as Rotation Axis

When you Right-Click at a pole in the Wulff-net a pop-up menu appears, from which you may choose "Set Rotation Axis". This will use the vector of the selected pole (hkl) or [uvw] as the rotation axis for all subsequent rotations. When selecting menu [View][Release Rotation Axis] or "Release Rotation Axis" from the same pop-up menu, the axis is discarded. As a shortcut one may also click at the two bottom right fields on the status bar, in order to release the axis.


New in 1.3.1

New Features in 1.3.1

A bug related to the extinction rules was fixed (e.g.: for the corundum example).


New in 1.4.0

New Features in 1.4.0

  • Fix: The reciprocal lattice matrix on the "Angles" tab was previously listed without being transposed
  • New: The alpha/beta import files (*.ab) can now be imported as rotatable pseudo-hkl sets in addition to the option as static overlays that was available in previous versions. No d-values and hkl indices are available, since the conversion to pseudo hkls only serves the purpose of creating cartesified 3D vectors so that they can be rotated.


New in 1.5.0

New Features in 1.5.0

1 - Sample Menu extended to 300

The file cellmenu.txt that contains the samples for the menu [Samples] can now contain up to 300 entries.

Because of the new Crystal Gmbh features (see below) each line may now contain up to three new parameters at the end, namely the orientation vector, reference hkl and dmin. For users that do not use the Crystal Gmbh method it may be useful to add the desired orientation vector only.

'New in 1.5 (Crystal Gmbh features):
' after the cell constants one may add the orientation vector, reference hkl and dmin
' example 1: 1 1 0 4 2 2 0.34 all three options three
' example 2: 1 1 0 4 2 2 orientation and reference added
' example 3: 1 1 0 only orientation vector (hkl) added

Example:

SrTiO3 : 221 PM3M 3.90528 3.90528 3.90528 90 90 90 1 1 0 4 2 2 0.62

The above line ends with "1 1 0 4 2 2 0.62", which means that (110) is the main(hkl)=orientation vector, (422) is a reference pole for the calculation of Alpha (see below) and 0.62 is the value to be used for dmin during the hkl generation.

2 - Features for the 'Crystal GMBH' company

Menu [Tools][Crystal GMBH]

Crystal Gmbh in Germany uses an energy dispersive system for the determination of crystal orientations. I have added features for them where an orientation vector, ie. main (hkl) and a reference (hkl) can be specified. The angle between them is called Ameas (alpha measured). Please note that the angle Alpha as used by Crystal Gmbh is actually the angle denoted Rho in WinWulff (as measured from the zenith). All poles within a strip of Alpha+/-5 deg are of interest to Crystal Gmbh. The strip can be highlighted and the corresponding poles exported for use in MS-Excel.

A pseudo energy value is calculated from the d-spacing values.